﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace fatura
{
    public partial class Form1 : Form
    {
        MySqlDataAdapter da_form1, da_urunler, da_musteri;
        public Form1()
        {
            InitializeComponent();

            MySqlConnectionStringBuilder bag = new MySqlConnectionStringBuilder();
            bag.Server = "localhost";
            bag.UserID = "root";
            bag.Password = "123456";
            bag.Database = "hafta14";

            MySqlConnection conn = new MySqlConnection(bag.ToString());


            MySqlCommand cmd_form1_sel = 
                new MySqlCommand("select fid,musterid,urunid,miktar,ad,urun,miktar*tutar from fatura inner join musteri on mid=musterid inner join urunler on uid=urunid",conn);

            MySqlCommand cmd_form1_ins = new MySqlCommand("insert into fatura(musterid,urunid,miktar) values(@musterid,@urunid,@miktar);",conn);
            cmd_form1_ins.Parameters.Add("@musterid", MySqlDbType.Int32, 11, "musterid");
            cmd_form1_ins.Parameters.Add("@urunid", MySqlDbType.Int32, 11, "urunid");
            cmd_form1_ins.Parameters.Add("@miktar", MySqlDbType.Int32, 11, "miktar");

            MySqlCommand cmd_form1_del = new MySqlCommand("delete from fatura where fid=@fid;", conn);
            cmd_form1_del.Parameters.Add("@fid", MySqlDbType.Int32, 11, "fid");
           

            da_form1 = new MySqlDataAdapter();
            da_form1.SelectCommand = cmd_form1_sel;
            da_form1.InsertCommand = cmd_form1_ins;
            da_form1.DeleteCommand = cmd_form1_del;


            MySqlCommand cmd_musteri_sel = new MySqlCommand("select mid,ad from musteri",conn);
            MySqlCommand cmd_musteri_ins = new MySqlCommand("insert into musteri(ad) values(@ad);", conn);
            cmd_musteri_ins.Parameters.Add("@ad", MySqlDbType.VarChar, 45, "ad");

            da_musteri = new MySqlDataAdapter();
            da_musteri.SelectCommand = cmd_musteri_sel;
            da_musteri.InsertCommand = cmd_musteri_ins;

            MySqlCommand cmd_urunler_sel = new MySqlCommand("select uid,urun,tutar from urunler", conn);
            MySqlCommand cmd_urunler_ins = new MySqlCommand("insert into urunler(urun,tutar) values(@urun,@tutar);", conn);
            cmd_urunler_ins.Parameters.Add("@urun", MySqlDbType.VarChar, 45, "urun");
            cmd_urunler_ins.Parameters.Add("@tutar", MySqlDbType.Double, 11, "tutar");
            MySqlCommand cmd_urunler_upd = new MySqlCommand("update urunler set urun=@urun,tutar=@tutar where uid=@uid;", conn);
            cmd_urunler_upd.Parameters.Add("@uid", MySqlDbType.Int32, 11, "uid");
            cmd_urunler_upd.Parameters.Add("@urun", MySqlDbType.VarChar, 45, "urun");
            cmd_urunler_upd.Parameters.Add("@tutar", MySqlDbType.Double, 11, "tutar");

            da_urunler = new MySqlDataAdapter();
            da_urunler.SelectCommand = cmd_urunler_sel;
            da_urunler.InsertCommand = cmd_urunler_ins;
            da_urunler.UpdateCommand = cmd_urunler_upd;
            verigetir(); 

        }

        private void çıkışToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void burunler_Click(object sender, EventArgs e)
        {
            furunler frm = new furunler(da_urunler);
            frm.ShowDialog();
            verigetir(); 

        }

        private void bmusteri_Click(object sender, EventArgs e)
        {
            fmusteri frm = new fmusteri(da_musteri);
            frm.ShowDialog();
            verigetir(); 

        }

        private void bsil_Click(object sender, EventArgs e)
        {

            if (lmusteri.SelectedIndex > -1)
            {
                dt_form1.Rows[lmusteri.SelectedIndex].Delete();
                da_form1.Update(dt_form1);
            }


            verigetir(); 
        }

        private void bekle_Click(object sender, EventArgs e)
        {
            int miktar;
            bool kmiktar = Int32.TryParse(tmiktar.Text, out miktar);

            if (kmiktar && curun.SelectedIndex > -1 && cmusteri.SelectedIndex > -1)
            {

                DataRow dr = dt_form1.NewRow();
                dr["musterid"] = Convert.ToInt32(dt_musteri.Rows[cmusteri.SelectedIndex].ItemArray[0].ToString()); // musteri id 
                dr["urunid"] = Convert.ToInt32(dt_urunler.Rows[curun.SelectedIndex].ItemArray[0].ToString()); // urun id
                dr["miktar"] = miktar;

                dt_form1.Rows.Add(dr);
                da_form1.Update(dt_form1);

                tmiktar.Clear();
                curun.Text = "Ürün Adı";
                cmusteri.Text = "Müşteri Adı";
            }

            verigetir(); 
        }


        DataTable dt_form1,dt_musteri,dt_urunler;
        private void verigetir()
        {
            dt_form1 = new DataTable();
            dt_musteri = new DataTable();
            dt_urunler = new DataTable();

            try
            {
                curun.Items.Clear();
                cmusteri.Items.Clear();
                lurun.Items.Clear();
                lmusteri.Items.Clear();
                lmiktar.Items.Clear();
                ltutar.Items.Clear();


                // listbox

                da_form1.Fill(dt_form1);

                for (int satir = 0; satir < dt_form1.Rows.Count; satir++)
                {
                    lmusteri.Items.Add(dt_form1.Rows[satir].ItemArray[4].ToString());
                    lurun.Items.Add(dt_form1.Rows[satir].ItemArray[5].ToString());
                    lmiktar.Items.Add(dt_form1.Rows[satir].ItemArray[3].ToString());
                    ltutar.Items.Add(dt_form1.Rows[satir].ItemArray[6].ToString());
                
                }

                // urunler combo
                da_urunler.Fill(dt_urunler);
                for (int satir = 0; satir < dt_urunler.Rows.Count; satir++)
                {
                    curun.Items.Add(dt_urunler.Rows[satir].ItemArray[1].ToString());
                }

                // musteri combo

                da_musteri.Fill(dt_musteri);
                for (int satir = 0; satir < dt_musteri.Rows.Count; satir++)
                {
                    cmusteri.Items.Add(dt_musteri.Rows[satir].ItemArray[1].ToString());
                }

            }
            catch { }
            cmusteri.Text = "Müşteri Adı";
            curun.Text = "Ürün Adı";
        
        }

        private void lmusteri_SelectedIndexChanged(object sender, EventArgs e)
        {
            ListBox lb = (ListBox)sender;

            lmusteri.SelectedIndex = lb.SelectedIndex;
            lurun.SelectedIndex = lb.SelectedIndex;
            lmiktar.SelectedIndex = lb.SelectedIndex;
            ltutar.SelectedIndex = lb.SelectedIndex;

        }

        private void cikisToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();   
        }

        private void hakkindaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mustafa Kemal Üniversitesi Mühendislik Fakültesi\n Bilgisayar Mühendisliği\n Nesneye Yönelik Uygulama Laboratuvarı Ders Örneği");
        }

      
    }
}
